Main Page | Namespace List | Class Hierarchy | Alphabetical List | Class List | File List | Namespace Members | Class Members | File Members

# DL_GroupParameters_IntegerBased Class Reference

`#include <gfpcrypt.h>`

Inheritance diagram for DL_GroupParameters_IntegerBased:

List of all members.

## Detailed Description

_

Definition at line 23 of file gfpcrypt.h.

## Public Types
typedef Integer | Element
## Public Member Functions
void | Initialize (const DL_GroupParameters_IntegerBased &params)
void | Initialize (RandomNumberGenerator &rng, unsigned int pbits)
void | Initialize (const Integer &p, const Integer &g)
void | Initialize (const Integer &p, const Integer &q, const Integer &g)
void | BERDecode (BufferedTransformation &bt)
| decode this object from a BufferedTransformation, using BER (Basic Encoding Rules)
void | DEREncode (BufferedTransformation &bt) const
| encode this object into a BufferedTransformation, using DER (Distinguished Encoding Rules)
void | GenerateRandom (RandomNumberGenerator &rng, const NameValuePairs &alg)
bool | GetVoidValue (const char *name, const std::type_info &valueType, void *pValue) const
| to be implemented by derived classes, users should use one of the above functions instead
void | AssignFrom (const NameValuePairs &source)
| assign values from source to this object
const Integer & | GetSubgroupOrder () const
Integer | GetGroupOrder () const
bool | ValidateGroup (RandomNumberGenerator &rng, unsigned int level) const
bool | ValidateElement (unsigned int level, const Integer &element, const DL_FixedBasePrecomputation< Integer > *precomp) const
bool | FastSubgroupCheckAvailable () const
void | EncodeElement (bool reversible, const Element &element, byte *encoded) const
unsigned int | GetEncodedElementSize (bool reversible) const
Integer | DecodeElement (const byte *encoded, bool checkForGroupMembership) const
Integer | ConvertElementToInteger (const Element &element) const
Integer | GetMaxExponent () const
OID | GetAlgorithmID () const
virtual const Integer & | GetModulus () const =0
virtual void | SetModulusAndSubgroupGenerator (const Integer &p, const Integer &g)=0
void | SetSubgroupOrder (const Integer &q)
| DL_GroupParameters ()
bool | Validate (RandomNumberGenerator &rng, unsigned int level) const
| check this object for errors
bool | SupportsPrecomputation () const
void | Precompute (unsigned int precomputationStorage=16)
| do precomputation
void | LoadPrecomputation (BufferedTransformation &storedPrecomputation)
| retrieve previously saved precomputation
void | SavePrecomputation (BufferedTransformation &storedPrecomputation) const
| save precomputation for later use
virtual const Element & | GetSubgroupGenerator () const
virtual void | SetSubgroupGenerator (const Element &base)
virtual Element | ExponentiateBase (const Integer &exponent) const
virtual Element | ExponentiateElement (const Element &base, const Integer &exponent) const
virtual const DL_GroupPrecomputation< Element > & | GetGroupPrecomputation () const =0
virtual const DL_FixedBasePrecomputation< Element > & | GetBasePrecomputation () const =0
virtual DL_FixedBasePrecomputation< Element > & | AccessBasePrecomputation ()=0
virtual Integer | GetCofactor () const
virtual void | EncodeElement (bool reversible, const Element &element, byte *encoded) const =0
virtual Integer | ConvertElementToInteger (const Element &element) const =0
virtual bool | ValidateElement (unsigned int level, const Element &element, const DL_FixedBasePrecomputation< Element > *precomp) const =0
virtual bool | IsIdentity (const Element &element) const =0
virtual void | SimultaneousExponentiate (Element *results, const Element &base, const Integer *exponents, unsigned int exponentsCount) const =0
void | GenerateRandomWithKeySize (RandomNumberGenerator &rng, unsigned int keySize)
| calls the above function with a NameValuePairs object that just specifies "KeySize"
virtual void | ThrowIfInvalid (RandomNumberGenerator &rng, unsigned int level) const
| throws InvalidMaterial if this object fails Validate() test
virtual void | Save (BufferedTransformation &bt) const
| save key into a BufferedTransformation
virtual void | Load (BufferedTransformation &bt)
| load key from a BufferedTransformation
void | DoQuickSanityCheck () const
template<class T>
bool | GetThisObject (T &object) const
| get a copy of this object or a subobject of it
template<class T>
bool | GetThisPointer (T *&p) const
| get a pointer to this object, as a pointer to T
template<class T>
bool | GetValue (const char *name, T &value) const
| get a named value, returns true if the name exists
template<class T>
T | GetValueWithDefault (const char *name, T defaultValue) const
| get a named value, returns the default if the name doesn't exist
std::string | GetValueNames () const
| get a list of value names that can be retrieved
bool | GetIntValue (const char *name, int &value) const
| get a named value with type int
int | GetIntValueWithDefault (const char *name, int defaultValue) const
| get a named value with type int, with default
template<class T>
void | GetRequiredParameter (const char *className, const char *name, T &value) const
void | GetRequiredIntParameter (const char *className, const char *name, int &value) const
void | Save (BufferedTransformation &bt) const
| save key into a BufferedTransformation
void | Load (BufferedTransformation &bt)
| load key from a BufferedTransformation
virtual void | BEREncode (BufferedTransformation &bt) const
| encode this object into a BufferedTransformation, using BER
## Static Public Member Functions
static std::string __cdecl | StaticAlgorithmNamePrefix ()
static void __cdecl | ThrowIfTypeMismatch (const char *name, const std::type_info &stored, const std::type_info &retrieving)
| used by derived classes to check for type mismatch
## Protected Member Functions
Integer | ComputeGroupOrder (const Integer &modulus) const
virtual int | GetFieldType () const =0
virtual unsigned int | GetDefaultSubgroupOrderSize (unsigned int modulusSize) const
void | ParametersChanged ()

## Member Function Documentation

void DL_GroupParameters_IntegerBased::GenerateRandom | ( | RandomNumberGenerator & | rng,
|  | const NameValuePairs & | alg
| ) | `[virtual]`

| parameters: (ModulusSize, SubgroupOrderSize (optional)) Reimplemented from GeneratableCryptoMaterial. Reimplemented in DL_GroupParameters_DSA. Definition at line 160 of file gfpcrypt.cpp. References ComputeGroupOrder(), PrimeAndGenerator::Generate(), PrimeAndGenerator::Generator(), GetDefaultSubgroupOrderSize(), NameValuePairs::GetIntValue(), NameValuePairs::GetIntValueWithDefault(), NameValuePairs::GetValue(), NameValuePairs::GetValueWithDefault(), Initialize(), PrimeAndGenerator::Prime(), and PrimeAndGenerator::SubPrime().

void DL_GroupParameters_IntegerBased::AssignFrom | ( | const NameValuePairs & | source | ) | `[virtual]`

| assign values from source to this object Note: This function can be used to create a public key from a private key. Implements CryptoMaterial. Reimplemented in DL_GroupParameters_IntegerBasedImpl< GROUP_PRECOMP, BASE_PRECOMP >, DL_GroupParameters_IntegerBasedImpl< DL_GroupPrecomputation_LUC, DL_BasePrecomputation_LUC >, and DL_GroupParameters_IntegerBasedImpl< ModExpPrecomputation >. Definition at line 230 of file gfpcrypt.cpp.

bool DL_GroupParameters< Integer >::Validate | ( | RandomNumberGenerator & | rng,
|  | unsigned int | level
| ) | const`[inline, virtual, inherited]`

  | check this object for errors Parameters:
  | level | denotes the level of thoroughness: 0 - using this object won't cause a crash or exception (rng is ignored) 1 - this object will probably function (encrypt, sign, etc.) correctly (but may not check for weak keys and such) 2 - make sure this object will function correctly, and do reasonable security checks 3 - do checks that may take a long time
Returns: true if the tests pass Implements CryptoMaterial. Definition at line 531 of file pubkey.h.

bool DL_GroupParameters< Integer >::SupportsPrecomputation | ( |  | ) | const`[inline, virtual, inherited]`

| Returns: whether this object supports precomputation Reimplemented from CryptoMaterial. Definition at line 555 of file pubkey.h.

void DL_GroupParameters< Integer >::Precompute | ( | unsigned int | precomputationStorage = `16` | ) | `[inline, virtual, inherited]`

| do precomputation The exact semantics of Precompute() is varies, but typically it means calculate a table of n objects that can be used later to speed up computation. Reimplemented from CryptoMaterial. Definition at line 557 of file pubkey.h.

virtual void CryptoMaterial::Load | ( | BufferedTransformation & | bt | ) | `[inline, virtual, inherited]`

  | load key from a BufferedTransformation Exceptions:
  | KeyingErr | if decode fails
Note: Generally does not check that the key is valid. Call ValidateKey() or ThrowIfInvalidKey() to check that. Reimplemented in ASN1CryptoMaterial. Definition at line 994 of file cryptlib.h.

bool NameValuePairs::GetIntValue | ( | const char * | name,
|  | int & | value
| ) | const`[inline, inherited]`

| get a named value with type int used to ensure we don't accidentally try to get an unsigned int or some other type when we mean int (which is the most common case) Definition at line 278 of file cryptlib.h. Referenced by InvertibleRWFunction::GenerateRandom(), InvertibleRSAFunction::GenerateRandom(), InvertibleRabinFunction::GenerateRandom(), InvertibleLUCFunction::GenerateRandom(), GenerateRandom(), DL_GroupParameters_DSA::GenerateRandom(), InvertibleESIGNFunction::GenerateRandom(), and Integer::GenerateRandomNoThrow().

void ASN1CryptoMaterial::Load | ( | BufferedTransformation & | bt | ) | `[inline, virtual, inherited]`

  | load key from a BufferedTransformation Exceptions:
  | KeyingErr | if decode fails
Note: Generally does not check that the key is valid. Call ValidateKey() or ThrowIfInvalidKey() to check that. Reimplemented from CryptoMaterial. Definition at line 52 of file simple.h. References ASN1Object::BERDecode().

virtual void ASN1Object::BEREncode | ( | BufferedTransformation & | bt | ) | const`[inline, virtual, inherited]`

| encode this object into a BufferedTransformation, using BER this may be useful if DEREncode() would be too inefficient Definition at line 1561 of file cryptlib.h. Referenced by ASN1CryptoMaterial::Save().

The documentation for this class was generated from the following files:

- gfpcrypt.h
- gfpcrypt.cpp